


XIncludeFile "PortAudio.pb"

Enumeration  
  ;****************for grafix thumbs code********
  #SourceImage
  #TargetImage1
  #TargetImage2
  #TargetImage3
  #TargetImage4
  #TargetImage5
  #TargetImage6
  #TargetImage7
  #TargetImage8
  ;************************
  #WIN_MAIN

  #MIDIDevice

  #Trackbar_Attack
  #Trackbar_Decay
  #Trackbar_Sustain
  #Trackbar_Release
  #Text_Attack
  #Text_Sustain
  #Text_Decay
  #Text_Release
  #GADGET_Canvas1
  #GADGET_Canvas2
  #GADGET_Canvas3
  #Button_Clear
  #Button_Render
  #Check_Log
  #Trackbar_Stacking
  
  ;#Trackbar_Time
  
  ;#GADGET_TextY
  
  #XYFirst
  
  #Frame_Envelope
  #Frame_MidiDevice
  #Text_Resolution
 
EndEnumeration

;*********for grafix thumbs code********
Enumeration
#ImageSource
  #ImageTarget1
  #ImageTarget2
  #ImageTarget3
  #ImageTarget4
  #ImageTarget5
  #ImageTarget6
  #ImageTarget7
  #ImageTarget8
  #OrigSource
  #BlankImage  
  #ImageScaledThumb
EndEnumeration
Global BigPictureCopy = #False
;*****************************

;********for grafix thumb code**************
Global NewList blankimageslist.l() ;keeps track of blank images
Global ListContainsElement = #False
;**************************************************

;****for grafix thumb code*********
CreateImage(#ImageScaledThumb, 257, 151)
;*******************



;*********for timeline code**********
Global VarAPoint1X.d = 0
Global VarAPoint1Y.d = 15
Global VarAPoint2X.d = 52
Global VarAPoint2Y.d = 15
Global VarAPoint3X.d = 104
Global VarAPoint3Y.d = 15
Global VarAPoint4X.d = 156
Global VarAPoint4Y.d = 15

Global VarAPoint5X.d = 208
Global VarAPoint5Y.d = 15

Global VarAPoint6X.d = 260
Global VarAPoint6Y.d = 15

Global VarAPoint7X.d = 312
Global VarAPoint7Y.d = 15

Global VarAPoint8X.d = 364
Global VarAPoint8Y.d = 15


Global VarAOrig2X.d = VarAPoint2X
Global VarAOrig3X.d = VarAPoint3X
Global VarAOrig4X.d = VarAPoint4X 
Global VarAOrig5X.d = VarAPoint5X
Global VarAOrig6X.d = VarAPoint6X
Global VarAOrig7X.d = VarAPoint7X 
Global VarAOrig8X.d = VarAPoint8X 

Global XYPointID.s = "Unpressed";this is so we know which point in the XY ADSR has been pressed so that when we drag the point it keeps up with the cursor

Global Dot1Color = $686868
Global Dot2Color = $686868
Global Dot3Color = $686868
Global Dot4Color = $686868
Global Dot5Color = $686868
Global Dot6Color = $686868
Global Dot7Color = $686868
Global Dot8Color = $686868

Global NewList Dlist.l()
Global NewList Timestamps.l()
Global NewList SpectrumSets.s()

Global Dim TimestampsArr.d(0)
Global Dim SpectrumSetsArr.d(0)


;****************************************


#SampleRate = 44100

#PI2 = 6.28318530717958

Global Pee.l
Global InitializeTheBezier.l=0

Global Phase.d=0
Global PhaseAdd.d

Global Kata.s

Global Foo.l

Global Pos.l=-1

Enumeration

EndEnumeration

Enumeration
  #Off
  #On
EndEnumeration


;*********timer thread stuff*************
Enumeration #PB_Event_FirstCustomValue
    #EventProcessing
  EndEnumeration
  Global tid_1 ;timer thread for playback of recording
;********end timer thread definitions**************  




Global State.i

Global SampleCounter.l

Global ForcedDecayCounter.l=0
Global Groucho.d=0
Global InitializeSampleCounter.l=0


;midi stuff
Global Chromatic$
Chromatic$="C C#D EbE F F#G AbA BbB C "
Global NoteVal.l
Global Freq.d
Global NoteCheck.i
Global foo.l
Global p.d
Global i.d

Global OldFreq.d=100

;ADSR stuff
Global Attack.d
Global Decay.d
Global Sustain.d
Global Release.d

Global AttackSamples.d
Global DecaySamples.d
Global SustainLevel.d
Global ReleaseSamples.d

Global ADSRLevel.d
Global UptoV.d ;the ADSR level we have reached when Release strikes
Global UptoP.l ;samplecount we have reached when the Release strikes


Global NewList mylist.s()
Global Dim MyArrayX.d(0)
Global Dim MyArrayY.d(0)


Global Dim SinCoeffs.d(31)
Global Dim CosCoeffs.d(31)
Global Dim ResynthesizedArr.d(256)
Global Dim SpectrumMagnitudes.d(31)

Global Dim SinAtan2.d(31)
Global Dim CosAtan2.d(31)

Global DCOffset.d
Global Scalefactor.d=1

Global ModifyWaveform.l=0


Global GlobalSamplePoint.l

Global Dim NewArrVal.d(128)


Declare.f CalculateTheWaveform(SamplePoint.l)

Declare bubblesortList(List TheList.s(), SortColumn.l)

Declare.d ValFromWavetable(TheXVal.d)

Declare.d Normalize()

Declare.d ValFromFourierSeries(Phh.d)

Declare CreateFourierSeries(ValsArray.s) ;ValsArray can take 2 values: "WT": (Wave Table) which only contains values initially drawn and so needs interpolation for all values, or "RA": (Resynthesized Array) which contains all 256 values

Declare DrawSpectrum()

Declare DrawInterpolatedSpectrum() 

Declare DrawResynthesizedWaveform(IncludeDCOffset.l=1)

Declare SpectrumSetsOperation(DaOperation.s, DaFromVal.l=0, DaToVal.l=0)

Declare.d InterpolatedSpectrumValDynamic(Phh.d) 

Declare EditThumb(ThumbNum.l)

Declare.d StackedWaveGraphHelper(SampleVal.l, Phh.d)

Global Took.l=1 ;for toggling on/off timer thread posting events to update drawing window

Global StackingVal.l 


Procedure Thread(Value)
  Repeat
    Delay(100)
    If State = #On
      Took = 0
    EndIf  
    If Took = 0  
        PostEvent(#EventProcessing)
    EndIf  
  ForEver
EndProcedure


Procedure.d Saw(Phh.d)
  Define Q.d 
  If Phh < 0.5
   Q = 0.35 * Sin(Phh)
  Else
   Q = (0.35 * Sin(1 - Phh)) + 0.5
  EndIf
ProcedureReturn Q
EndProcedure


Procedure.i MIDI_GetInputDevices()
 
  Protected mic.MIDIINCAPS, Num.i, i.i
 
  Num = midiInGetNumDevs_()
  For i = 0 To Num - 1
    If midiInGetDevCaps_(i, @mic, SizeOf(MIDIINCAPS)) = 0
      AddGadgetItem(#MIDIDevice, -1, PeekS(@mic\szPname))
    EndIf
  Next i
 
  ProcedureReturn Num
 
EndProcedure


Procedure.s MIDI_Note(Note);returns note's name
   ProcedureReturn Trim(Mid(Chromatic$, (Note % 12) * 2 + 1, 2)) + Str(Note / 12)
EndProcedure


Procedure MidiInCallback(hMidiIn.i, wMsg.i, dwInstance.l, dwParam1.l, dwParam2.l)
 
  Protected Note.i, Velocity.i, Status.i
  Static KeyCounter.i
  
  Select wMsg    ; process MIDI in events
    Case #MIM_CLOSE
      KeyCounter = 0
      State = #Off
      kata = "Off"
    Case #MM_MIM_DATA
      Status = dwParam1 & $FF
      If Status = $90
        Note = (dwParam1 >> 8) & $FF
        Velocity = (dwParam1 >> 16) & $FF
        If Velocity
          Freq = Pow(2, (Note - 69) / 12) * 440

          If KeyCounter = 0
            State = #On
            kata = "On"
          EndIf
          KeyCounter + 1
        Else
          If KeyCounter : KeyCounter - 1 : EndIf
          If KeyCounter = 0
          State = #Off
          kata = "Off"
          InitializeTheBezier = 0
          InitializeSampleCounter = 0
          OldFreq = Freq
          EndIf
        EndIf
      EndIf 
      
      If Status = $80
        If KeyCounter : KeyCounter - 1 : EndIf
        If KeyCounter = 0
          State = #Off 
          kata = "Off"
          InitializeTheBezier = 0
          InitializeSampleCounter = 0
          OldFreq = Freq
        EndIf
      EndIf
      
      If IsStatusBar(0) : StatusBarText(0, 1, kata, #PB_StatusBar_Center) : EndIf

  EndSelect
EndProcedure
;end midi stuff


Procedure Error(err)
  MessageRequester("PortAudio", PeekS(Pa_GetErrorText(err)))
  End
EndProcedure


Procedure ElapsedTimeBetweenActiveDots()
  ClearList(Dlist())
  ClearList(Timestamps())
  
  If Dot1Color = $00FF00
    AddElement(Dlist()) : Dlist() = VarAPoint1X
  EndIf  
  If Dot2Color = $00FF00
    AddElement(Dlist()) : Dlist() = VarAPoint2X
  EndIf  
  If Dot3Color = $00FF00
    AddElement(Dlist()) : Dlist() = VarAPoint3X
  EndIf  
  If Dot4Color = $00FF00
    AddElement(Dlist()) : Dlist() = VarAPoint4X
  EndIf  
  If Dot5Color = $00FF00
    AddElement(Dlist()) : Dlist() = VarAPoint5X
  EndIf  
  If Dot6Color = $00FF00
    AddElement(Dlist()) : Dlist() = VarAPoint6X
  EndIf  
  If Dot7Color = $00FF00
    AddElement(Dlist()) : Dlist() = VarAPoint7X
  EndIf  
  If Dot8Color = $00FF00
    AddElement(Dlist()) : Dlist() = VarAPoint8X
  EndIf 
  
  AddElement(Timestamps()) : Timestamps() = 0
   
  
  If ListSize(Dlist())>1
    For voo = 0 To ListSize(Dlist())-2
      SelectElement(Dlist(), voo) 
      If voo = 0
        ThePreVal = Dlist()
      EndIf  
      SelectElement(Dlist(), voo+1)
      TheNextVal = Dlist()
      TheElapsedTime = (TheNextVal - ThePreVal)*440 ;it is 105 pixels between each dot max. So we are saying 1 sec between each dot max (at SR=44100 samples/sec)
      AddElement(Timestamps()) : Timestamps() = TheElapsedTime
    Next voo  
  EndIf  
  
   
ReDim TimestampsArr(ListSize(Timestamps())-1)


Text$ = ""
For voo = 0 To ListSize(Timestamps())-1
  SelectElement(Timestamps(), voo)
  TimestampsArr(voo) = Timestamps()
  Text$ = Text$ + StrD(TimestampsArr(voo))+ Chr($d)
Next voo  
SetClipboardText(text$)


  StrHoo.s = ""
  ResetList(Timestamps())
  While NextElement(Timestamps())
  StrHoo = StrHoo + Str(Timestamps()) + ";"  
  Wend  
  
EndProcedure  


Procedure SpectrumSetsOperation(DaOperation.s, DaFromVal.l=0, DaToVal.l=0)
  
;Operation and Val values:
;"Add": DaFromVal required - if a record against DaFromVal already exists, it is deleted and then new record created. If it does not exist, a new record is simply created
;"Move": DaFromVal and DaToVal required
;"Del": DaFromVal required (ID of record to delete)
;"Exch": DaFromVal and DaToVal required (IDs of records to exchange) 
  
  ;StackingVal = GetGadgetState(#Trackbar_Stacking)
  StackingVal = -GetGadgetState(#Trackbar_Stacking)+53 
  
  Select DaOperation

      Case "Move"
          ResetList(SpectrumSets())
            While NextElement(SpectrumSets())
              If DaFromVal = Val(StringField(SpectrumSets(),2,";")) 
               PreStr.s = StringField(SpectrumSets(),1,";")
               DeleteElement(SpectrumSets())
               AddElement(SpectrumSets()) : SpectrumSets() = PreStr + ";" + Str(DaToVal) 
              EndIf  
            Wend   
            
     Case "Exch"
       ResetList(SpectrumSets())
            While NextElement(SpectrumSets())
              If DaFromVal = Val(StringField(SpectrumSets(),2,";")) 
                ThePreStr.s = StringField(SpectrumSets(),1,";")
                DeleteElement(SpectrumSets())
                AddElement(SpectrumSets()) : SpectrumSets() = ThePreStr + ";" + "A"
              EndIf
              If DaToVal = Val(StringField(SpectrumSets(),2,";")) 
                ThePreStr = StringField(SpectrumSets(),1,";")
                DeleteElement(SpectrumSets())
                AddElement(SpectrumSets()) : SpectrumSets() = ThePreStr + ";" + "B"
              EndIf
            Wend 
            
            ResetList(SpectrumSets())
            While NextElement(SpectrumSets())
              If StringField(SpectrumSets(),2,";") = "A" 
                ThePreStr = StringField(SpectrumSets(),1,";")
                DeleteElement(SpectrumSets())
                AddElement(SpectrumSets()) : SpectrumSets() = ThePreStr + ";" + Str(DaToVal)
              EndIf
              If StringField(SpectrumSets(),2,";") = "B" 
                ThePreStr = StringField(SpectrumSets(),1,";")
                DeleteElement(SpectrumSets())
                AddElement(SpectrumSets()) : SpectrumSets() = ThePreStr + ";" + Str(DaFromVal)
              EndIf
            Wend 
            
      Case "Del"      
            ResetList(SpectrumSets())
            While NextElement(SpectrumSets())
              If DaFromVal = Val(StringField(SpectrumSets(),2,";")) 
                DeleteElement(SpectrumSets())
              EndIf  
            Wend 
       
      Case "Add" 
            ResetList(SpectrumSets())
            While NextElement(SpectrumSets())
              If DaFromVal = Val(StringField(SpectrumSets(),2,";")) 
                DeleteElement(SpectrumSets())
              EndIf  
            Wend   

            CreateFourierSeries("RA")
	          DrawSpectrum()
	          For tj = 0 To 31
	            AddElement(SpectrumSets()) : SpectrumSets() = StrD(Pow(((SinCoeffs(tj)*SinCoeffs(tj)) + (CosCoeffs(tj)*CosCoeffs(tj))),0.5)) +  ":" + SinCoeffs(tj) + ":" + CosCoeffs(tj) + ";" + Str(DaFromVal) 
	          Next tj
  
      EndSelect
      
      bubblesortList(SpectrumSets(),2)
      
      Text$ = ""
      
If ListSize(SpectrumSets())>0      
      
      For tj = 0 To 31
        SelectElement(SpectrumSets(), tj) 
        SinAtan2(tj) = Sin(ATan2(ValD(StringField(SpectrumSets(),3,":")),ValD(StringField(SpectrumSets(),2,":"))))
        CosATan2(tj) = Cos(ATan2(ValD(StringField(SpectrumSets(),3,":")),ValD(StringField(SpectrumSets(),2,":"))))
        ;Text$ = Text$ + StrD(SinAtan2(tj)) + ";" + StrD(CosATan2(tj)) + Chr($d)
      Next tj
      
       
       ReDim SpectrumSetsArr(ListSize(SpectrumSets())-1)
       For tj = 0 To ListSize(SpectrumSets())-1
         SelectElement(SpectrumSets(), tj)
         SpectrumSetsArr(tj) = ValD(StringField(SpectrumSets(),1,":")) 
       Next tj 
EndIf       


If ListSize(mylist())=0 And ListSize(SpectrumSets())=0
    DisableGadget(#Check_Log,1)
    If StartDrawing(CanvasOutput(#GADGET_Canvas2))
    Box(0, 0, 257, 151, $000000)      
    StopDrawing()
    EndIf
EndIf

       
EndProcedure 


Procedure bubblesortList(List TheList.s(), SortColumn.l)
  Protected iu, itemCount, hasChanged
  itemCount = (ListSize(TheList()))-1 
  Repeat
    hasChanged = #False
    itemCount-1
    For iu = 0 To itemCount
      SelectElement(TheList(), iu)
      *FirstElement = @TheList()
      buBi.l = Val(StringField(TheList(),SortColumn,";"))
      SelectElement(TheList(), iu+1)
      *SecondElement = @TheList()
      buBiPlusOne.l = Val(StringField(TheList(),SortColumn,";"))
      If buBi>buBiPlusOne
        SwapElements(TheList(), *FirstElement, *SecondElement)
        hasChanged = #True
      EndIf
    Next
  Until hasChanged = #False
EndProcedure 




Procedure.f CalculateTheWaveform(SamplePoint.l)
  GlobalSamplePoint = SamplePoint
  
  Protected PlayVal.f
  
If Freq>0
  If ForcedDecayCounter<=1000
    PhaseAdd = (OldFreq/#SampleRate)
  Else  
      PhaseAdd = (Freq/#SampleRate)
  EndIf  
   
    Phase = Phase + PhaseAdd
    
    If Phase>=1
      Phase = Phase-1
    EndIf  

    
    If ListSize(SpectrumSets())>0 
    PlayVal = InterpolatedSpectrumValDynamic(Phase)
    Else
    PlayVal = 0
    EndIf  
EndIf  
  
ProcedureReturn PlayVal
     
EndProcedure  



Procedure.d ValFromFourierSeries(Phh.d)
Protected ck.d = 0
Protected hoo.l
For hoo = 1 To 32
ck = ck + (SinCoeffs(hoo-1)*Sin((hoo*(#Pi2)*Phh))) + (CosCoeffs(hoo-1)*Cos((hoo*(#Pi2)*Phh))) 
Next hoo
ck = ck + DCOffset
ck = Scalefactor*ck
ProcedureReturn ck
EndProcedure  



Procedure.d InterpolatedSpectrumValDynamic(Phh.d) 
  
Protected TimeVal.l 
Protected cq.d = 0
Protected Ponto.d
Protected ThePos.l=0
Protected CapitalTee.d
Protected LittleTee.d
Protected ValFrom.d
Protected ValTo.d
Protected FirstTime.d
Protected SecondTime.d
  
TimeVal = GlobalSamplePoint 

        
If ArraySize(TimestampsArr())>0
    If TimeVal < TimestampsArr(ArraySize(TimestampsArr()))
          For koo = 0 To ArraySize(TimestampsArr())
            If TimeVal<TimestampsArr(koo)
              CapitalTee = TimestampsArr(koo) - TimestampsArr(koo-1)
              LittleTee = TimeVal - TimestampsArr(koo-1)
              ThePos = koo
              Break
            EndIf
          Next koo 
    Else
          ThePos = ArraySize(TimestampsArr())
          LittleTee = 1
          CapitalTee = 1
    EndIf
EndIf        
      ;
   
For koo = 0 To 31       
        
     If ArraySize(TimestampsArr())>0  
        IndexFrom = ((ThePos-1)*32) + koo
        IndexTo = ((ThePos-1+1)*32) + koo
        ValFrom = SpectrumSetsArr(IndexFrom)
        ValTo = SpectrumSetsArr(IndexTo)
        Ponto = ((ValTo - ValFrom)*(LittleTee/CapitalTee)) + ValFrom
     Else
        ValFrom = SpectrumSetsArr(koo)
        Ponto = ValFrom 
     EndIf         
        
        cq = cq + (Ponto*SinAtan2(koo)*Sin((koo+1)*(#Pi2)*Phh)) + (Ponto*CosATan2(koo)*Cos((koo+1)*(#Pi2)*Phh))
    
Next koo
 

ProcedureReturn cq 


EndProcedure



Procedure.d StackedWaveGraphHelper(SampleVal.l, Phh.d)
   
Protected Ponti.d
Protected LePos.l=0
Protected CTee.d
Protected LTee.d
Protected VFrom.d
Protected VTo.d
Protected cs.d

If ArraySize(TimestampsArr())>0
    If SampleVal < TimestampsArr(ArraySize(TimestampsArr()))
          For uoo = 0 To ArraySize(TimestampsArr())
            If SampleVal<TimestampsArr(uoo)
              CTee = TimestampsArr(uoo) - TimestampsArr(uoo-1)
              LTee = SampleVal - TimestampsArr(uoo-1)
              LePos = uoo
              Break
            EndIf
          Next uoo 
    Else
          LePos = ArraySize(TimestampsArr())
          LTee = 1
          CTee = 1
    EndIf
EndIf        
      
    
For uoo = 0 To 31
        
     If ArraySize(TimestampsArr())>0  
        xFrom = ((LePos-1)*32) + uoo
        xTo = ((LePos-1+1)*32) + uoo
        VFrom = SpectrumSetsArr(xFrom)
        VTo = SpectrumSetsArr(xTo)
        Ponti = ((VTo - VFrom)*(LTee/CTee)) + VFrom
     Else
        VFrom = SpectrumSetsArr(uoo)
        Ponti = VFrom 
     EndIf  
        
        cs = cs + (Ponti*SinAtan2(uoo)*Sin((uoo+1)*(#Pi2)*Phh)) + (Ponti*CosATan2(uoo)*Cos((uoo+1)*(#Pi2)*Phh))
    
Next uoo
 

ProcedureReturn cs 


EndProcedure  



Procedure StackedWaveGrapher()
  
  Protected VeryLastTimeStamp.l
  Protected TheFraction.d
  RefreshTheDraw = #False
  
Text$ =""  

#LoopLimit = 126
SampleTimeSteps.l = TimestampsArr(ArraySize(TimestampsArr()))/(#LoopLimit/StackingVal)

VeryLastTimeStamp = TimestampsArr(ArraySize(TimestampsArr()))

TheFraction = 0
If VeryLastTimeStamp>0
   While TheFraction<=0.92 
      For nq = 0 To #LoopLimit
        TheFraction = (((nq/StackingVal)*SampleTimeSteps)/VeryLastTimeStamp)
        nq = nq+StackingVal-1
      Next nq
   StackingVal = StackingVal - 1   
   Wend   
 EndIf
 
 
If VeryLastTimeStamp>0 And TheFraction>0.92
  RefreshTheDraw = #True
ElseIf VeryLastTimeStamp = 0
  RefreshTheDraw = #True
EndIf  
  
  
If RefreshTheDraw = #True  
  
        StartDrawing(CanvasOutput(#GADGET_Canvas3)) 
        Box(0, 0, 257, 151, $000000) 
 
        For nq = 0 To #LoopLimit  
        Text$ = Text$ + Str(nq*SampleTimeSteps) + ";" + Str(TimestampsArr(ArraySize(TimestampsArr()))) + Chr($d)   
           For tq = 0 To 128  
              foz.d = 140 - ((25/128)*(128-tq))
              TheWaveVal.d = StackedWaveGraphHelper(((nq/StackingVal)*SampleTimeSteps), (tq/128))*-1
              XpNo = tq+nq
              YpNo = 20*TheWaveVal-(nq*0.8) ;reduce from 30 to say 10 for gentle waves or increase to 40 for even rougher waves
              YpNo = YpNo + foz
              NewArrVal(tq) = YpNo
            Next tq 
                      For tq = 1 To 128
                          LineXY((tq-1)+nq, NewArrVal(tq-1), (tq+nq), NewArrVal(tq), $FFFF00)  
                      Next tq 
         nq = nq+StackingVal-1     
         Next nq  
         StopDrawing()  
         SetClipboardText(Text$) 
         
EndIf         
         
EndProcedure  



Procedure.d ValFromWavetable(TheXVal.d)
  
Protected listPos.l=-1
Protected ext.d
Protected wy1.d
Protected wy0.d
Protected ex1.d
Protected ex0.d 
Protected wyt.d
  
ext=TheXVal

Repeat 
  listPos = listPos+1
  If listPos>ArraySize(MyArrayX())
    wy0 = MyArrayY(ArraySize(MyArrayY())-1)
    ex0 = MyArrayX(ArraySize(MyArrayX())-1)
    If ex0<=251
      wy1 = 75
      ex1 = 256
      Else
      wy1 = wy0
      ex1 = 256
    EndIf
    
    Break
  EndIf  
Until ext<MyArrayX(listPos)

  If listPos<=ArraySize(MyArrayX())
      wy1 = MyArrayY(listPos)
      ex1 = MyArrayX(listPos)
      If listPos>=1 
        wy0 = MyArrayY(listPos-1)
        ex0 = MyArrayX(listPos-1)
      Else ;meaning listPos = 0
        If MyArrayX(0)>=4
        wy0 = 75
        ex0 = 0
        Else
        wy0 = wy1
        ex0 = 0
        EndIf
      EndIf  
  EndIf  
;linear interpolation between the two points: wyt = ((wy1-wy0)*(ext-ex0)/(ex1-ex0))+wy0:
  If ex0 = ex1
    wyt = wy0
  Else  
    wyt = ((wy1-wy0)*(ext-ex0)/(ex1-ex0))+wy0 
  EndIf  
   
ProcedureReturn wyt
  
EndProcedure  



Procedure.d Normalize()
  Protected last, ii, ret.d
  ret = ResynthesizedArr(0)
  last = ArraySize(ResynthesizedArr())
  For ii = 1 To last
    If ret<Abs(ResynthesizedArr(ii))
      ret = Abs(ResynthesizedArr(ii))
    EndIf  
  Next

  If Abs(ret)>1
    ScaleFactor = 1/Abs(ret)
         For ii = 0 To last
          ResynthesizedArr(ii) = ResynthesizedArr(ii)*ScaleFactor
        Next    
  EndIf  
EndProcedure



;******for grafix thumb code************
Procedure DrawScaledThumbImage()
   
If StartDrawing(ImageOutput(#ImageScaledThumb))
   Box(0, 0, 257, 151, $000000)  
   For vi = 0 To 31
       LineXY((16+(vi*7)), 150, (16+(vi*7)), (150-(SpectrumMagnitudes(vi)*1.8*150)), $FFFF00)
       LineXY((17+(vi*7)), 150, (17+(vi*7)), (150-(SpectrumMagnitudes(vi)*1.8*150)), $FFFF00)          
   Next vi
StopDrawing()
EndIf      
   
EndProcedure  
;****************************


Procedure CreateFourierSeries(ValsArray.s)
    
For ai = 1 To 32
            ci.d = 0
            For xi = 0 To 256
                ;get the sine harmonics values:
		If ValsArray = "WT"
		RefactoredVals.d = ((75-ValFromWavetable(xi*1.0))/75)
		ElseIf ValsArray = "RA"
		  RefactoredVals = ResynthesizedArr(xi)
		EndIf	
                ki.d = RefactoredVals*Sin((ai*(#Pi2)*xi/256))  
              ;*******apply simpson's rule************
              If xi<>0 And xi<>256
                If Mod(xi,2)
                  ki = ki*4
                Else
                  ki = ki*2
                EndIf
              EndIf 
            ;*****************************************  
              ci = ci+ki 
            Next xi
              ci = (1/3)*ci 
              ci = ci/128
          
              SinCoeffs(ai-1) = ci
              ;Text$ = Text$ + StrD(ci) + Chr($d)
      
 Next ai          
            
 For ai = 1 To 32
            ci = 0
            For xi = 0 To 256
                ;get the cos harmonics values:
		If ValsArray = "WT"
		RefactoredVals = ((75-ValFromWavetable(xi*1.0))/75)
		ElseIf ValsArray = "RA"
		  RefactoredVals = ResynthesizedArr(xi)
		EndIf	
                ki.d = RefactoredVals*Cos((ai*(#Pi2)*xi/256))  
              ;*******apply simpson's rule************
              If xi<>0 And xi<>256
                If Mod(xi,2)
                  ki = ki*4
                Else
                  ki = ki*2
                EndIf
              EndIf 
            ;*****************************************  
              ci = ci+ki 
            Next xi
              ci = (1/3)*ci 
              ci = ci/128
            
              CosCoeffs(ai-1) = ci
      
 Next ai         
            
  ;Now let us get the DC offset:
  For xi = 0 To 256
                ;get the sine harmonics values:
		If ValsArray = "WT"
		RefactoredVals = ((75-ValFromWavetable(xi*1.0))/75)
		ElseIf ValsArray = "RA"
		  RefactoredVals = ResynthesizedArr(xi)
		EndIf	
                ki = RefactoredVals
              ;*******apply simpson's rule************
              If xi<>0 And xi<>256
                If Mod(xi,2)
                  ki = ki*4
                Else
                  ki = ki*2
                EndIf
              EndIf 
            ;*****************************************  
              ci = ci+ki 
 Next xi
              ci = (1/3)*ci 
              ci = ci/256
            DCOffset = ci 

EndProcedure




Procedure DrawSpectrum()
For ai = 0 To 31
SpectrumMagnitudes(ai) = Pow(((SinCoeffs(ai)*SinCoeffs(ai)) + (CosCoeffs(ai)*CosCoeffs(ai))),0.5) 
Next ai
            
If StartDrawing(CanvasOutput(#GADGET_Canvas2))
   Box(0, 0, 257, 151, $000000)  
   For ai = 0 To 31
       If GetGadgetState(#Check_Log) = 0
       LineXY((16+(ai*7)), 150, (16+(ai*7)), (150-(SpectrumMagnitudes(ai)*150)), $FFFF00)
       LineXY((17+(ai*7)), 150, (17+(ai*7)), (150-(SpectrumMagnitudes(ai)*150)), $FFFF00) 
       Else
       LineXY((16+(ai*7)), 150, (16+(ai*7)), Abs(20*Log10(SpectrumMagnitudes(ai)))*3, $FFFF00)
       LineXY((17+(ai*7)), 150, (17+(ai*7)), Abs(20*Log10(SpectrumMagnitudes(ai)))*3, $FFFF00)
       EndIf          
   Next ai
StopDrawing()
EndIf    

EndProcedure  





Procedure EditThumb(ThumbNum.l)

Protected Mags.d  
  
boo=-1  
ResetList(SpectrumSets())
While NextElement(SpectrumSets())
  If ThumbNum = Val(StringField(SpectrumSets(),2,";"))
   Mags =  ValD(StringField(SpectrumSets(),1,":"))
   boo = boo+1
   SpectrumMagnitudes(boo) = Mags
   CosCoeffs(boo) = Mags*CosAtan2(boo)
   SinCoeffs(boo) = Mags*SinAtan2(boo)
  EndIf 
Wend 

DrawSpectrum()
DrawResynthesizedWaveform(0)
    
EndProcedure  



Procedure DrawInterpolatedSpectrum() 
  
Protected CurTimel.l ;Current Time 
Protected CurSpecMag.d ;Current Spectrum Magnitude
Protected Posi.l=0
Protected CapTee.d
Protected LitTee.d
Protected ValueFrom.d
Protected ValueTo.d
  
CurTime = GlobalSamplePoint 


If ArraySize(TimestampsArr())>0
    If CurTime < TimestampsArr(ArraySize(TimestampsArr()))
    	For doo = 0 To ArraySize(TimestampsArr())
    	If CurTime<TimestampsArr(doo)
       	CapTee = TimestampsArr(doo) - TimestampsArr(doo-1)
        	LitTee = CurTime - TimestampsArr(doo-1)
        	Posi = doo
        	Break
     	EndIf
     	Next doo 
    Else
              Posi = ArraySize(TimestampsArr())
              LitTee = 1
              CapTee = 1
    EndIf
EndIf


If ListSize(DList())>0
        If StartDrawing(CanvasOutput(#GADGET_Canvas2))
           Box(0, 0, 257, 151, $000000)  
        
            For doo = 0 To 31      
              
              If ArraySize(TimestampsArr())>0
              	IdxFrom = ((Posi-1)*32) + doo
              	IdxTo = ((Posi-1+1)*32) + doo
              	ValueFrom = SpectrumSetsArr(IdxFrom)
              	ValueTo = SpectrumSetsArr(IdxTo)
              	CurSpecMag = ((ValueTo - ValueFrom)*(LitTee/CapTee)) + ValueFrom
              Else
                ValueFrom = SpectrumSetsArr(doo)
                CurSpecMag = ValueFrom
              EndIf  
            
                 	If GetGadgetState(#Check_Log) = 0
            
                       		LineXY((16+(doo*7)), 150, (16+(doo*7)), (150-CurSpecMag*150), $FFFF00)
                       		LineXY((17+(doo*7)), 150, (17+(doo*7)), (150-CurSpecMag*150), $FFFF00) 
                	 Else
                          LoguVal.d = Abs(20*Log10(CurSpecMag))*3
                              If LoguVal>130.6
                                 LoguVal = 130.6
                              EndIf 
                         	LineXY((16+(doo*7)), 150, (16+(doo*7)), LoguVal, $FFFF00)
                         	LineXY((17+(doo*7)), 150, (17+(doo*7)),LoguVal, $FFFF00)
             
                   EndIf          
            
            Next doo
            
        StopDrawing()
        EndIf 
        
EndIf        

EndProcedure





Procedure DrawResynthesizedWaveform(IncludeDCOffset.l=1)
  
StartDrawing(CanvasOutput(#GADGET_Canvas1))

Box(0, 0, 257, 151, $000000)
LineXY(64, 0, 64, 150, $0000FF)
LineXY(128, 0, 128, 150, $0000FF)
LineXY(192, 0, 192, 150, $0000FF)
LineXY(0, 75, 257, 75, $0000FF)
                          
For ti = 0 To 256
qi.d = 0
     For bi = 1 To 32
     qi = qi + (SinCoeffs(bi-1)*Sin((bi*(#Pi2)*ti/256))) + (CosCoeffs(bi-1)*Cos((bi*(#Pi2)*ti/256))) 
   Next bi
If IncludeDCOffset=1   
  qi = qi + DCOffset
EndIf  
ResynthesizedArr(ti) = qi
Next ti 
                          
Normalize()
                          
For ti = 0 To 256
qi = ResynthesizedArr(ti)
XpN = ti
YpN = 75*(1-qi)
If ti>0
LineXY(XpO, YpO, XpN, YpN, $FFFF00)  
EndIf
XpO = XpN
YpO = YpN
Next ti         
                          
StopDrawing()
                          

EndProcedure  



Procedure LevelADSR(SampleTracker.l) 

If SampleTracker>2147483640
SampleCounter = 0
UptoV = 0
EndIf  
 
If State = #Off
    If (ReleaseSamples+UptoP-SampleTracker)>=0
      ADSRLevel = (UptoV*(ReleaseSamples+UptoP-SampleTracker))/ReleaseSamples  
    Else
      ADSRLevel = 0
    EndIf 
    Groucho = ADSRLevel
  If IsStatusBar(0)
  EndIf
EndIf
 
 If State = #On
   If InitializeTheBezier = 0
     InitializeTheBezier = 1
     ForcedDecayCounter = -1

      
      Attack = GetGadgetState(#Trackbar_Attack) / 1000
      Decay = GetGadgetState(#Trackbar_Decay) / 1000
      Sustain = GetGadgetState(#Trackbar_Sustain) / 100
      Release = GetGadgetState(#Trackbar_Release) / 1000
      
      AttackSamples = Attack*#SampleRate
      DecaySamples = Decay*#SampleRate
      SustainLevel = Sustain
      ReleaseSamples = Release*#SampleRate
            
    EndIf
    
    ForcedDecayCounter = ForcedDecayCounter+1
    If ForcedDecayCounter<=1000
      ADSRLevel = (1-Pow((ForcedDecayCounter/1000),1))*Groucho
    Else
      ;got to set the following only the FIRST TIME ForcedDecayCounter increments above 1000 samples:
      If InitializeSampleCounter = 0
        pee = -1
        Phase = 0
      InitializeSampleCounter = 1  
      SampleCounter = 0
      SampleTracker = 0
      EndIf
      ;let us calculate the actual ADSR level now shall we
          If SampleTracker<=AttackSamples
            ADSRLevel = SampleTracker/AttackSamples
          ElseIf SampleTracker>AttackSamples And SampleTracker<=(AttackSamples+DecaySamples)
            ADSRLevel = SustainLevel + (((AttackSamples+DecaySamples-SampleTracker)*(1-SustainLevel))/DecaySamples)
          ElseIf SampleTracker>(AttackSamples+DecaySamples)
            ADSRLevel = SustainLevel
          EndIf
    EndIf      
    UptoV = ADSRLevel
    UptoP = SampleTracker
EndIf   

EndProcedure


ProcedureC PaStreamCallback(*in, *output.Float, frameCount, *timeInfo.PaStreamCallbackTimeInfo, statusFlags, *userData)

  While frameCount
    LevelADSR(SampleCounter)
         If SampleCounter<100
           *output\f = CalculateTheWaveform(SampleCounter)*ADSRLevel*Pow((SampleCounter/100),5)
         Else
           *output\f = CalculateTheWaveform(SampleCounter)*ADSRLevel
         EndIf  
   SampleCounter = SampleCounter+1  
   
   *output + 4
   frameCount - 1
Wend
 
EndProcedure


Define err.i

err = Pa_Initialize()
If err <> #paNoError : Error(err) : EndIf

Define op.PaStreamParameters
op\channelCount = 1
op\device = Pa_GetDefaultOutputDevice()
op\sampleFormat = #paFloat32
op\suggestedLatency = 75/1000


;err = Pa_OpenStream(@Stream, #Null, @op, #SampleRate, #SampleRate / 100, #paNoFlag, @PaStreamCallback(), 0)
err = Pa_OpenStream(@Stream, #Null, @op, #SampleRate, #paframesperbufferunspecified, #paNoFlag, @PaStreamCallback(), 0)
If err <> #paNoError : Error(err) : EndIf

Define Indev.i
InDev = 0

Define hMi.i
hMi = 0

If OpenWindow(#WIN_MAIN, 0, 0, 795, 400, "Wavefuser Sound Synthsizer", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  
  FrameGadget(#Frame_Envelope, 10,300,485,40, "Volume Envelope")
  FrameGadget(#Frame_MidiDevice, 570,300,200,40, "MIDI Device")

  ButtonGadget(#Button_Clear, 140, 165, 60, 20, "clear")
  ButtonGadget(#Button_Render, 70, 165, 60, 20, "render")
  
  CanvasGadget(#GADGET_Canvas1, 10, 10, 257, 151, #PB_Canvas_ClipMouse) ;for graphing the waveform
  CanvasGadget(#GADGET_Canvas2, 270, 10, 257, 151, #PB_Canvas_ClipMouse);for the harmonics spectrum
  CanvasGadget(#GADGET_Canvas3, 530, 10, 257, 151, #PB_Canvas_ClipMouse) ;for the harmonics spectrum
  
  CanvasGadget(#XYFirst, 10, 260, 760, 30) 
  
    If StartDrawing(CanvasOutput(#XYFirst))
      Box(0, 0, 760, 30, $000000)
        LineXY(VarAPoint1X, VarAPoint1Y, VarAPoint2X, VarAPoint2Y, $686868) 
        LineXY(VarAPoint2X, VarAPoint2Y, VarAPoint3X, VarAPoint3Y, $686868) 
        LineXY(VarAPoint3X, VarAPoint3Y, VarAPoint4X, VarAPoint4Y, $686868) 
        LineXY(VarAPoint4X, VarAPoint4Y, VarAPoint5X, VarAPoint5Y, $686868) 
        LineXY(VarAPoint5X, VarAPoint5Y, VarAPoint6X, VarAPoint6Y, $686868) 
        LineXY(VarAPoint6X, VarAPoint6Y, VarAPoint7X, VarAPoint7Y, $686868)
        LineXY(VarAPoint7X, VarAPoint7Y, VarAPoint8X, VarAPoint8Y, $686868) 
      
        Circle(VarAPoint1X, VarAPoint1Y, 5, Dot1Color)
        Circle(VarAPoint2X, VarAPoint2Y, 5, Dot2Color)
        Circle(VarAPoint3X, VarAPoint3Y, 5, Dot3Color)
        Circle(VarAPoint4X, VarAPoint4Y, 5, Dot4Color)
        Circle(VarAPoint5X, VarAPoint5Y, 5, Dot5Color)
        Circle(VarAPoint6X, VarAPoint6Y, 5, Dot6Color)
        Circle(VarAPoint7X, VarAPoint7Y, 5, Dot7Color)
        Circle(VarAPoint8X, VarAPoint8Y, 5, Dot8Color)
        

        StopDrawing()
      EndIf
  
  

  
  StartDrawing(CanvasOutput(#GADGET_Canvas1))
  Box(0, 0, 257, 151, $000000)
  LineXY(64, 0, 64, 150, $0000FF)
  LineXY(128, 0, 128, 150, $0000FF)
  LineXY(192, 0, 192, 150, $0000FF)
  LineXY(0, 75, 257, 75, $0000FF)
  StopDrawing()
   
  
  StartDrawing(CanvasOutput(#GADGET_Canvas2))
  Box(0, 0, 257, 151, $000000)
  StopDrawing()
  
  StartDrawing(CanvasOutput(#GADGET_Canvas3))
  Box(0, 0, 257, 151, $000000)
  StopDrawing()
  
  
  CheckBoxGadget(#Check_Log, 375,  165, 50, 20, "Log")
  DisableGadget(#Check_Log,1)

  TrackBarGadget(#Trackbar_Attack, 30, 315, 100, 20, 1, 2000)
  TrackBarGadget(#Trackbar_Decay, 150, 315, 100, 20, 1, 5000)
  TrackBarGadget(#Trackbar_Sustain, 270, 315, 100, 20, 0, 100)
  SetGadgetState(#Trackbar_Sustain, 50)

  TrackBarGadget(#Trackbar_Release, 390, 315, 100, 20, 1, 5000)
  SetGadgetState(#Trackbar_Attack, 1)
  SetGadgetState(#Trackbar_Decay, 1000)
  SetGadgetState(#Trackbar_Release, 1500)
 
  TextGadget(#Text_Attack, 20, 315, 10, 20, "A")
  TextGadget(#Text_Decay, 140, 315, 10, 20, "D")
  TextGadget(#Text_Sustain, 260, 315, 10, 20, "S")
  TextGadget(#Text_Release, 380, 315, 10, 20, "R")
    
  TrackBarGadget(#Trackbar_Stacking, 630, 165, 100, 20, 3, 50)
  SetGadgetState(#Trackbar_Stacking, 43)
  
  TextGadget(#Text_Resolution, 580, 165, 60, 20, "Resolution")
  
        ;**********grafix thumbs code****************
  
  CreateImage(#ImageSource, 257, 151)
 
  CreateImage(#OrigSource, 257, 151)
  
  CreateImage(#BlankImage, 86, 50)
  If StartDrawing(ImageOutput(#BlankImage))
    Box(0, 0, 86, 50, $FFFFFF)
    StopDrawing()
  EndIf 
 
 
  CreateImage(#ImageTarget1, 86, 50)
  CopyImage(#BlankImage, #ImageTarget1)
 
  CreateImage(#ImageTarget2, 86, 50)
  CopyImage(#BlankImage, #ImageTarget2)
 
  CreateImage(#ImageTarget3, 86, 50)
  CopyImage(#BlankImage, #ImageTarget3)

  CreateImage(#ImageTarget4, 86, 50)
  CopyImage(#BlankImage, #ImageTarget4)
  
  
  CreateImage(#ImageTarget5, 86, 50)
  CopyImage(#BlankImage, #ImageTarget5)
 
  CreateImage(#ImageTarget6, 86, 50)
  CopyImage(#BlankImage, #ImageTarget6)
 
  CreateImage(#ImageTarget7, 86, 50)
  CopyImage(#BlankImage, #ImageTarget7)

  CreateImage(#ImageTarget8, 86, 50)
  CopyImage(#BlankImage, #ImageTarget8)
  
  ImageGadget(#TargetImage1, 10, 200, 86, 50, ImageID(#ImageTarget1))
  ImageGadget(#TargetImage2, 106, 200, 86, 50, ImageID(#ImageTarget2))
  ImageGadget(#TargetImage3, 202, 200, 86, 50, ImageID(#ImageTarget3))
  ImageGadget(#TargetImage4, 298, 200, 86, 50, ImageID(#ImageTarget4))
  ImageGadget(#TargetImage5, 394, 200, 86, 50, ImageID(#ImageTarget5))
  ImageGadget(#TargetImage6, 490, 200, 86, 50, ImageID(#ImageTarget6))
  ImageGadget(#TargetImage7, 586, 200, 86, 50, ImageID(#ImageTarget7))
  ImageGadget(#TargetImage8, 682, 200, 86, 50, ImageID(#ImageTarget8))
  
  EnableGadgetDrop(#TargetImage1,    #PB_Drop_Image,   #PB_Drag_Copy)
  EnableGadgetDrop(#TargetImage2,    #PB_Drop_Image,   #PB_Drag_Copy)
  EnableGadgetDrop(#TargetImage3,    #PB_Drop_Image,   #PB_Drag_Copy)
  EnableGadgetDrop(#TargetImage4,    #PB_Drop_Image,   #PB_Drag_Copy)
  EnableGadgetDrop(#TargetImage5,    #PB_Drop_Image,   #PB_Drag_Copy)
  EnableGadgetDrop(#TargetImage6,    #PB_Drop_Image,   #PB_Drag_Copy)
  EnableGadgetDrop(#TargetImage7,    #PB_Drop_Image,   #PB_Drag_Copy)
  EnableGadgetDrop(#TargetImage8,    #PB_Drop_Image,   #PB_Drag_Copy)
  
  EnableGadgetDrop(#GADGET_Canvas2,    #PB_Drop_Image,   #PB_Drag_Copy)
  EnableGadgetDrop(#GADGET_Canvas1,    #PB_Drop_Image,   #PB_Drag_Copy)
  
  AddElement(blankimageslist()) : blankimageslist() = 1
  AddElement(blankimageslist()) : blankimageslist() = 2
  AddElement(blankimageslist()) : blankimageslist() = 3
  AddElement(blankimageslist()) : blankimageslist() = 4
  AddElement(blankimageslist()) : blankimageslist() = 5
  AddElement(blankimageslist()) : blankimageslist() = 6
  AddElement(blankimageslist()) : blankimageslist() = 7
  AddElement(blankimageslist()) : blankimageslist() = 8
  
  ;****************************************************

  
  If CreateMenu(0, WindowID(#WIN_MAIN)) 
    ; menu creation starts....
      MenuTitle("?")
        MenuItem(1, "About")
        ;MenuItem(2, "Help")
    EndIf
  

  ComboBoxGadget(#MIDIDevice, 600, 315, 140, 20)
  If MIDI_GetInputDevices()
    SetGadgetState(#MIDIDevice, 0)
    InDev = 0
  Else
    InDev = -1
  EndIf
  
 
  
  If CreateStatusBar(0, WindowID(#WIN_MAIN))
    AddStatusBarField(100)
    AddStatusBarField(100)
    AddStatusBarField(30)
  EndIf
 
  AddKeyboardShortcut(#WIN_MAIN, #PB_Shortcut_Escape, 111)


  ;MIDI STUFF for NOTE ON/OFF DISPLAY
  If midiInOpen_(@hMi, InDev, @MidiInCallback(), 0, #CALLBACK_FUNCTION) = #MMSYSERR_NOERROR
    If midiInStart_(hMi) = #MMSYSERR_NOERROR
      If IsStatusBar(0) : StatusBarText(0, 0, "MIDI IN", #PB_StatusBar_Center) : EndIf
    Else
      If IsStatusBar(0) : StatusBarText(0, 0, "No MIDI IN", #PB_StatusBar_Center) : EndIf
    EndIf
  Else
    If IsStatusBar(0) : StatusBarText(0, 0, "No MIDI IN", #PB_StatusBar_Center) : EndIf
  EndIf
 
  ;END MIDI STUFF
  
  

  
 
  State = #Off
  Pa_StartStream(Stream)
  tid_1 = CreateThread(@Thread(), 0)
 
  Define Quit.i
  Quit = #False
  
  
  
  Define Event.i
  Repeat
    Event = WaitWindowEvent()
    
    EventGadget = EventGadget()
    
    
  ;**********grafix thumb code**********************  
  If Event = #PB_Event_Gadget And EventType() = #PB_EventType_LeftDoubleClick 
      Select EventGadget()
        Case #TargetImage1 
          CopyImage(#BlankImage, #ImageTarget1)
          SetGadgetState(#TargetImage1, ImageID(#ImageTarget1))
                    ResetList(blankimageslist())
                    ListContainsElement = #False
                    While NextElement(blankimageslist())
                    If blankimageslist() = #ImageTarget1
                      ListContainsElement = #True
                      Break
                    EndIf  
                    Wend  
                    If Not ListContainsElement
                      AddElement(blankimageslist()) : blankimageslist() = 1
                    EndIf
                    ResetList(blankimageslist()) 
                    Dot1Color = $686868
        Case #TargetImage2 
          CopyImage(#BlankImage, #ImageTarget2)
          SetGadgetState(#TargetImage2, ImageID(#ImageTarget2)) 
                    ResetList(blankimageslist())
                    ListContainsElement = #False
                    While NextElement(blankimageslist())
                    If blankimageslist() = #ImageTarget2
                      ListContainsElement = #True
                      Break
                    EndIf  
                    Wend  
                    If Not ListContainsElement
                      AddElement(blankimageslist()) : blankimageslist() = 2
                    EndIf
                    ResetList(blankimageslist())  
                    Dot2Color = $686868
        Case #TargetImage3 
          CopyImage(#BlankImage, #ImageTarget3)
          SetGadgetState(#TargetImage3, ImageID(#ImageTarget3))
                    ResetList(blankimageslist())
                    ListContainsElement = #False
                    While NextElement(blankimageslist())
                    If blankimageslist() = #ImageTarget3
                      ListContainsElement = #True
                      Break
                    EndIf  
                    Wend  
                    If Not ListContainsElement
                      AddElement(blankimageslist()) : blankimageslist() = 3
                    EndIf
                    ResetList(blankimageslist()) 
                    Dot3Color = $686868
        Case #TargetImage4 
          CopyImage(#BlankImage, #ImageTarget4)
          SetGadgetState(#TargetImage4, ImageID(#ImageTarget4)) 
                    ResetList(blankimageslist())
                    ListContainsElement = #False
                    While NextElement(blankimageslist())
                    If blankimageslist() = #ImageTarget4
                      ListContainsElement = #True
                      Break
                    EndIf  
                    Wend  
                    If Not ListContainsElement
                      AddElement(blankimageslist()) : blankimageslist() = 4
                    EndIf
                    Dot4Color = $686868
       Case #TargetImage5 
          CopyImage(#BlankImage, #ImageTarget5)
          SetGadgetState(#TargetImage5, ImageID(#ImageTarget5)) 
                    ResetList(blankimageslist())
                    ListContainsElement = #False
                    While NextElement(blankimageslist())
                    If blankimageslist() = #ImageTarget5
                      ListContainsElement = #True
                      Break
                    EndIf  
                    Wend  
                    If Not ListContainsElement
                      AddElement(blankimageslist()) : blankimageslist() = 5
                    EndIf 
                    Dot5Color = $686868
       Case #TargetImage6 
          CopyImage(#BlankImage, #ImageTarget6)
          SetGadgetState(#TargetImage6, ImageID(#ImageTarget6)) 
                    ResetList(blankimageslist())
                    ListContainsElement = #False
                    While NextElement(blankimageslist())
                    If blankimageslist() = #ImageTarget6
                      ListContainsElement = #True
                      Break
                    EndIf  
                    Wend  
                    If Not ListContainsElement
                      AddElement(blankimageslist()) : blankimageslist() = 6
                    EndIf  
                    Dot6Color = $686868
        Case #TargetImage7 
          CopyImage(#BlankImage, #ImageTarget7)
          SetGadgetState(#TargetImage7, ImageID(#ImageTarget7)) 
                    ResetList(blankimageslist())
                    ListContainsElement = #False
                    While NextElement(blankimageslist())
                    If blankimageslist() = #ImageTarget7
                      ListContainsElement = #True
                      Break
                    EndIf  
                    Wend  
                    If Not ListContainsElement
                      AddElement(blankimageslist()) : blankimageslist() = 7
                    EndIf 
                    Dot7Color = $686868
        Case #TargetImage8 
          CopyImage(#BlankImage, #ImageTarget8)
          SetGadgetState(#TargetImage8, ImageID(#ImageTarget8)) 
                    ResetList(blankimageslist())
                    ListContainsElement = #False
                    While NextElement(blankimageslist())
                    If blankimageslist() = #ImageTarget8
                      ListContainsElement = #True
                      Break
                    EndIf  
                    Wend  
                    If Not ListContainsElement
                      AddElement(blankimageslist()) : blankimageslist() = 8
                    EndIf
                    Dot8Color = $686868
        EndSelect 
                
        StartDrawing(CanvasOutput(#XYFirst))
                  Circle(VarAPoint1X, VarAPoint1Y, 5, Dot1Color)
                  Circle(VarAPoint2X, VarAPoint2Y, 5, Dot2Color)
                  Circle(VarAPoint3X, VarAPoint3Y, 5, Dot3Color)
                  Circle(VarAPoint4X, VarAPoint4Y, 5, Dot4Color)
                  Circle(VarAPoint5X, VarAPoint5Y, 5, Dot5Color)
                  Circle(VarAPoint6X, VarAPoint6Y, 5, Dot6Color)
                  Circle(VarAPoint7X, VarAPoint7Y, 5, Dot7Color)
                  Circle(VarAPoint8X, VarAPoint8Y, 5, Dot8Color)
         StopDrawing()       
         
         ElapsedTimeBetweenActiveDots()
         
         SpectrumSetsOperation("Del",EventGadget)
         
         If ListSize(SpectrumSets())>0 
           StackedWaveGrapher()
         Else
           StartDrawing(CanvasOutput(#GADGET_Canvas3)) 
           Box(0, 0, 257, 151, $000000) 
           StopDrawing()  
         EndIf  
         
         
         
    EndIf  
    ;********************************************************************
    
    

    
    Select Event
        
        
    Case #PB_Event_GadgetDrop
        Select EventGadget
          Case #TargetImage1 To #TargetImage8
            DropImage = EventDropImage(#PB_Any)
            If DropImage
              If FromGadget > #SourceImage And FromGadget <> EventGadget
                CopyImage(#ImageTarget1 + (EventGadget - #TargetImage1), #ImageTarget1 + (FromGadget - #TargetImage1))
                SetGadgetState(FromGadget, ImageID(#ImageTarget1 + (EventGadget - #TargetImage1)))
              EndIf
              CopyImage(DropImage, #ImageTarget1 + (EventGadget - #TargetImage1))
              SetGadgetState(EventGadget, ImageID(#ImageTarget1 + (EventGadget - #TargetImage1)))
              ;check if eventgadget is in the list of gadgets with blank images. if it is, then remove it from the list, and add to the list
              ;fromgadget as the gadget which now contains the blank image:
                    ToIsBlank = #False
                    ResetList(blankimageslist())
                    While NextElement(blankimageslist())
                      If blankimageslist() = EventGadget
                      ToIsBlank = #True  
                      DeleteElement(blankimageslist())
                      AddElement(blankimageslist()) : blankimageslist() = FromGadget

                              If EventGadget = 1
                                Dot1Color = $00FF00
                              ElseIf EventGadget = 2 
                                Dot2Color = $00FF00
                              ElseIf EventGadget = 3 
                                Dot3Color = $00FF00
                              ElseIf EventGadget = 4 
                                Dot4Color = $00FF00
                              ElseIf EventGadget = 5 
                                Dot5Color = $00FF00
                              ElseIf EventGadget = 6 
                                Dot6Color = $00FF00
                              ElseIf EventGadget = 7 
                                Dot7Color = $00FF00 
                              ElseIf EventGadget = 8 
                                Dot8Color = $00FF00
                              EndIf  
                      
                              If fromgadget = 1
                                Dot1Color = $686868
                              ElseIf fromgadget = 2 
                                Dot2Color = $686868
                              ElseIf fromgadget = 3 
                                Dot3Color = $686868
                              ElseIf fromgadget = 4 
                                Dot4Color = $686868
                              ElseIf fromgadget = 5 
                                Dot5Color = $686868
                              ElseIf fromgadget = 6 
                                Dot6Color = $686868
                              ElseIf fromgadget = 7 
                                Dot7Color = $686868 
                              ElseIf fromgadget = 8 
                                Dot8Color = $686868
                              EndIf 
                              
                              StartDrawing(CanvasOutput(#XYFirst))
                              Circle(VarAPoint1X, VarAPoint1Y, 5, Dot1Color)
                              Circle(VarAPoint2X, VarAPoint2Y, 5, Dot2Color)
                              Circle(VarAPoint3X, VarAPoint3Y, 5, Dot3Color)
                              Circle(VarAPoint4X, VarAPoint4Y, 5, Dot4Color)
                              Circle(VarAPoint5X, VarAPoint5Y, 5, Dot5Color)
                              Circle(VarAPoint6X, VarAPoint6Y, 5, Dot6Color)
                              Circle(VarAPoint7X, VarAPoint7Y, 5, Dot7Color)
                              Circle(VarAPoint8X, VarAPoint8Y, 5, Dot8Color)
                              StopDrawing() 
                              
                              ElapsedTimeBetweenActiveDots()
                              
                              SpectrumSetsOperation("Move", FromGadget, EventGadget)
                              StackedWaveGrapher()
                               
                    EndIf  
                    Wend  
              
                    If ToIsBlank = #False ;which means it is not a move image to a blank spot, but exchange images
                      SpectrumSetsOperation("Exch", FromGadget, EventGadget) 
                      StackedWaveGrapher()
                    EndIf  
             
              FreeImage(DropImage)
            EndIf
            
          Case #GADGET_Canvas2
            ModifyWaveform = 1
            DisableGadget(#Button_Render,1)
            EditThumb(FromGadget)
            
          Case #GADGET_Canvas1 
            ModifyWaveform = 1
            DisableGadget(#Button_Render,1)
            EditThumb(FromGadget)
            
        EndSelect    
        
        
        
      Case #EventProcessing  
        DrawInterpolatedSpectrum()
        If GlobalSamplePoint >  TimestampsArr(ArraySize(TimestampsArr()))
          Took = 1
        EndIf  

      Case #PB_Event_Menu
        
        Select EventMenu()
        Case 1
        MessageRequester("About", "Wavefuser v1.01 " + Chr(169) + " Jim Singh" + Chr(13) + "Waveform Harmonics Morphing" + Chr(13) +  "Sound Synthesizer")
        EndSelect
       
        If EventMenu() = 111 : Quit = #True : EndIf
         
       
      Case #PB_Event_Gadget
        Select EventGadget()
            
            
            
         Case #GADGET_Canvas1
            If EventType() = #PB_EventType_LeftButtonDown Or (EventType() = #PB_EventType_MouseMove And GetGadgetAttribute(#GADGET_Canvas1, #PB_Canvas_Buttons) & #PB_Canvas_LeftButton)
              x = GetGadgetAttribute(#GADGET_Canvas1, #PB_Canvas_MouseX)
              y = GetGadgetAttribute(#GADGET_Canvas1, #PB_Canvas_MouseY)
                    If ModifyWaveform = 0        
                      If StartDrawing(CanvasOutput(#GADGET_Canvas1))
                        Circle(x, y, 1, RGB($00,$00,$FF))  
                        AddElement(mylist()) : mylist() = StrD(x) + ";" + StrD(y)
                      StopDrawing()
                      EndIf
                    EndIf
                    
                    
                    If ModifyWaveform = 1
                      StartDrawing(CanvasOutput(#GADGET_Canvas1))
                      Box(0, 0, 257, 151, $000000)
                      LineXY(64, 0, 64, 150, $0000FF)
                      LineXY(128, 0, 128, 150, $0000FF)
                      LineXY(192, 0, 192, 150, $0000FF)
                      LineXY(0, 75, 257, 75, $0000FF)
                      
                        ResynthesizedArr(x) = (75-y)/75
                        For hi = 0 To 256
                          cf.d = ResynthesizedArr(hi)
                	        XpNew = hi
                	        YpNew = 75*(1-cf)
                            If hi>0
                	          LineXY(XpOld, YpOld, XpNew, YpNew, $FFFF00)  
                	          EndIf
                	        XpOld = XpNew
                          YpOld = YpNew
                        Next hi 
                        StopDrawing()
                        
                        CreateFourierSeries("RA")
                        DrawSpectrum()
                    EndIf  
                          
                    
           EndIf 
                  
           
              If EventType() = #PB_EventType_LeftButtonUp
                If ModifyWaveform = 1
                  DrawResynthesizedWaveform()
                EndIf 
              EndIf    
              
              
              If EventType() = #PB_EventType_RightButtonDown And ListSize(mylist())>0
                  BigPictureCopy = #True
              EndIf  
              
              
              
           
            
            Case #Button_Clear
            ModifyWaveform = 0
            If StartDrawing(CanvasOutput(#GADGET_Canvas1))
              ClearList(mylist())
                Box(0, 0, 257, 151, $000000)
                LineXY(64, 0, 64, 150, $0000FF)
                LineXY(128, 0, 128, 150, $0000FF)
                LineXY(192, 0, 192, 150, $0000FF)
                LineXY(0, 75, 257, 75, $0000FF)
              StopDrawing()
            EndIf  
            
            If StartDrawing(CanvasOutput(#GADGET_Canvas2))
            Box(0, 0, 257, 151, $000000)      
            StopDrawing()
            EndIf
            
            DisableGadget(#Button_Render,0)
            
            If ListSize(SpectrumSets())=0
              DisableGadget(#Check_Log,1)
            EndIf
            
            
          Case #Button_Render
            
            If ListSize(mylist())>0
              
            DisableGadget(#Check_Log,0)  
                          
            ModifyWaveform = 1
            
            Pos = -1
            
            Repeat
              Pos = Pos + 1  
              SelectElement(mylist(), Pos)
              StrToMatch.s = StringField(mylist(),1,";")   
                  While NextElement(mylist())
                    If StringField(mylist(),1,";") = StrToMatch
                      DeleteElement(mylist())
                    EndIf  
                  Wend  
            Until Pos>=(ListSize(mylist()))-1    
            
            bubblesortList(mylist(),1)
            
            
            
            ReDim MyArrayX(ListSize(mylist()))
            ReDim MyArrayY(ListSize(mylist()))

            Toom.l = -1
            ResetList(mylist())
            While NextElement(mylist())
              Toom = Toom + 1
              MyArrayX(Toom) = Val(StringField(mylist(),1,";")) 
              MyArrayY(Toom) = Val(StringField(mylist(),2,";")) 
            Wend 

            
            If StartDrawing(CanvasOutput(#GADGET_Canvas1))
              Box(0, 0, 257, 151, $000000)
              LineXY(64, 0, 64, 150, $0000FF)
              LineXY(128, 0, 128, 150, $0000FF)
              LineXY(192, 0, 192, 150, $0000FF)
              LineXY(0, 75, 257, 75, $0000FF)
              
            ResetList(mylist()) ;positions listindex to before first element
            While NextElement(mylist()) 
              
              XpointNew.d = Val(StringField(mylist(),1,";"))
              YpointNew.d = Val(StringField(mylist(),2,";"))
              
              If ListIndex(mylist())>0
              LineXY(XpointOld, YpointOld, XpointNew, YpointNew, $FFFF00)  
              EndIf
              
              XpointOld = XpointNew
              YpointOld = YpointNew
              
            Wend  
            
            
            SelectElement(mylist(), 0)
            
            XpointNew = Val(StringField(mylist(),1,";"))
            YpointNew = Val(StringField(mylist(),2,";"))
            If Val(StringField(mylist(),1,";"))>=4
              XpointOld = 0
              YpointOld = 75
            Else
              XpointOld = 0
              YpointOld = YpointNew
            EndIf  
            LineXY(XpointOld, YpointOld, XpointNew, YpointNew, $FFFF00)
            
            SelectElement(mylist(), ListSize(mylist())-1)
            
            XpointOld = Val(StringField(mylist(),1,";"))
            YpointOld = Val(StringField(mylist(),2,";"))
            If Val(StringField(mylist(),1,";"))<=251
              XpointNew = 256
              YpointNew = 75
            Else
              XpointNew = 256
              YpointNew = YpointOld
            EndIf  
            LineXY(XpointOld, YpointOld, XpointNew, YpointNew, $FFFF00)
        
            StopDrawing()
            EndIf 
            
            
            ;fourier coefficients:
            
            CreateFourierSeries("WT")
            
            ;Now we resynthesize the waveform according To the fourier series we have analyzed:************ 
            
            DrawResynthesizedWaveform()
            
            DrawSpectrum()
            
            DisableGadget(#Button_Render,1)
          EndIf  
            
        Case #Check_Log 
        ;If ModifyWaveform = 1 
            If StartDrawing(CanvasOutput(#GADGET_Canvas2))
            Box(0, 0, 257, 151, $000000)  
            For ai = 0 To 31
              If GetGadgetState(#Check_Log) = 0
              LineXY((16+(ai*7)), 150, (16+(ai*7)), (150-(SpectrumMagnitudes(ai)*150)), $FFFF00)
              LineXY((17+(ai*7)), 150, (17+(ai*7)), (150-(SpectrumMagnitudes(ai)*150)), $FFFF00) 
            Else
              LogVal.d = Abs(20*Log10(SpectrumMagnitudes(ai)))*3
              If LogVal>130.6
                LogVal = 130.6
              EndIf  
              LineXY((16+(ai*7)), 150, (16+(ai*7)), LogVal, $FFFF00)
              LineXY((17+(ai*7)), 150, (17+(ai*7)), LogVal, $FFFF00)
              EndIf
            Next ai
          StopDrawing()
          EndIf 
        ;EndIf   
          
          
            Case #GADGET_Canvas2
              If (EventType() = #PB_EventType_LeftButtonDown Or (EventType() = #PB_EventType_MouseMove And GetGadgetAttribute(#GADGET_Canvas2, #PB_Canvas_Buttons) & #PB_Canvas_LeftButton)) And ModifyWaveform = 1  
          
              xo = GetGadgetAttribute(#GADGET_Canvas2, #PB_Canvas_MouseX)
              yo = GetGadgetAttribute(#GADGET_Canvas2, #PB_Canvas_MouseY)

          		moo.l=-1
          		For ai = 0 To 31
            		If (xo>= 16+(ai*7)-2) And (xo<= 16+(ai*7)+3)
            		moo = ai
            		Break
            		EndIf
          		Next ai
          		If moo>-1
          		StartDrawing(CanvasOutput(#GADGET_Canvas2))
          		LineXY((16+(ai*7)), 150, (16+(ai*7)), 0, $000000)
              LineXY((17+(ai*7)), 150, (17+(ai*7)), 0, $000000) 
          
              LineXY((16+(ai*7)), 150, (16+(ai*7)), yo, $FFFF00)
              LineXY((17+(ai*7)), 150, (17+(ai*7)), yo, $FFFF00) 
              StopDrawing()
              

            ;now we reflect the change in magnitude of the harmonic, back into the waveform graph. we do it with these steps:
            ;1. identify which index value in spectrummangnitudes() array, coscoeffs() array and sincoeffs() array has changed. that value is: moo
             ;To convert the new magnitude into cos And sin weights,and write back into the cos, sin And magnitudes arrays:
            ;2. the new magnitude value on the spectrum graph is yo. to convert to actual magnitude, it now depends whether #check_log is ticked or not:
            ;if #check_log is NOT ticked: actual magnitude = (150-yo)/150. If #check_log IS ticked: actual magnitude = Pow(10, (-yo/(20*3))) 
            ;3. The phase angle does not change. so, get the current phase angle as follows: phase = Atan2(Coscoeffs(moo)/Sincoeffs(moo))
            ;4. calculate and insert into cos and sin coeffs arrays the new cos and sin coeffs as follows: coscoeffs(moo) = actual magnitude*cos(phase). sincoeffs(moo) = actual magnistude*sin(phase)
            ;5. calculate and insert into magnitudes array the actual magnitude: spectrummagnitudes(moo) = actual magnitude
            ;recalculate ReSynthesizedArr and draw waveform graph from that
              
              If GetGadgetState(#Check_Log) = 0
                CosCoeffs(moo) = ((150-yo)/150)*Cos(ATan2(Coscoeffs(moo),Sincoeffs(moo)))
                SinCoeffs(moo) = ((150-yo)/150)*Sin(ATan2(Coscoeffs(moo),Sincoeffs(moo)))
                SpectrumMagnitudes(moo) = ((150-yo)/150) 
              Else
                Multiplier.d = Pow(10, (-yo/(20*3)))
                If Multiplier<0.0066
                  Multiplier = 0
                EndIf  
                CosCoeffs(moo) = Multiplier*Cos(ATan2(Coscoeffs(moo),Sincoeffs(moo)))
                SinCoeffs(moo) = Multiplier*Sin(ATan2(Coscoeffs(moo),Sincoeffs(moo)))
                SpectrumMagnitudes(moo) = Multiplier
              EndIf
              
             
                DrawResynthesizedWaveform()
              
          	 EndIf
          	 

	          EndIf 
	          
	          If EventType() = #PB_EventType_RightButtonDown And ModifyWaveform = 1   
                  BigPictureCopy = #True
              EndIf  
	          
	          
                
                
          Case #TargetImage1 To #TargetImage8      
            If EventType() = #PB_EventType_LeftClick And BigPictureCopy = #True And ModifyWaveform = 1 
                                
                    ResetList(blankimageslist())
                    While NextElement(blankimageslist())
                    If blankimageslist() = EventGadget
                    DeleteElement(blankimageslist())
                    EndIf  
                    Wend  
                   
            StartDrawing(CanvasOutput(#XYFirst))   
            If EventGadget = 1
              Dot1Color = $00FF00
              Circle(VarAPoint1X, VarAPoint1Y, 5, Dot1Color)
            ElseIf EventGadget = 2 
              Dot2Color = $00FF00
              Circle(VarAPoint2X, VarAPoint2Y, 5, Dot2Color)
            ElseIf EventGadget = 3 
              Dot3Color = $00FF00
              Circle(VarAPoint3X, VarAPoint3Y, 5, Dot3Color)  
            ElseIf EventGadget = 4 
              Dot4Color = $00FF00
              Circle(VarAPoint4X, VarAPoint4Y, 5, Dot4Color)
            ElseIf EventGadget = 5 
              Dot5Color = $00FF00
              Circle(VarAPoint5X, VarAPoint5Y, 5, Dot5Color)  
            ElseIf EventGadget = 6 
              Dot6Color = $00FF00
              Circle(VarAPoint6X, VarAPoint6Y, 5, Dot6Color) 
            ElseIf EventGadget = 7 
              Dot7Color = $00FF00
              Circle(VarAPoint7X, VarAPoint7Y, 5, Dot7Color)  
            ElseIf EventGadget = 8 
              Dot8Color = $00FF00
              Circle(VarAPoint8X, VarAPoint8Y, 5, Dot8Color)
            EndIf  
            StopDrawing() 
            
            ElapsedTimeBetweenActiveDots()
            
            SpectrumSetsOperation("Add", EventGadget)
            
            StackedWaveGrapher()
            
                DrawScaledThumbImage()
                CopyImage(#ImageScaledThumb, #ImageSource)
                ResizeImage(#ImageSource, 86, 50)
                CopyImage(#ImageSource, #ImageTarget1 + (EventGadget - #TargetImage1))
                SetGadgetState(EventGadget, ImageID(#ImageTarget1 + (EventGadget - #TargetImage1)))
  
            BigPictureCopy = #False    
                
      EndIf          
                
                
  
                
            If EventType() = #PB_EventType_DragStart
              FromGadget = EventGadget
                    ResetList(blankimageslist())
                    ListContainsElement = #False
                    While NextElement(blankimageslist())
                    If blankimageslist() = EventGadget
                      ListContainsElement = #True
                      Break
                    EndIf  
                    Wend  
                    If Not ListContainsElement
                      DragImage(ImageID(#ImageTarget1 + (EventGadget - #TargetImage1)))
                    EndIf
              
            EndIf    
                
                         
           
          Case #MIDIDevice
            midiInStop_(hMi)
            midiInClose_(hMi)
            InDev = GetGadgetState(#MIDIDevice)
            midiInOpen_(@hMi, InDev, @MidiInCallback(), 0, #CALLBACK_FUNCTION)
            If midiInStart_(hMi) = #MMSYSERR_NOERROR
              If IsStatusBar(0) : StatusBarText(0, 0, "MIDI IN", #PB_StatusBar_Center) : EndIf
            Else
              If IsStatusBar(0) : StatusBarText(0, 0, "No MIDI IN", #PB_StatusBar_Center) : EndIf
            EndIf
           
          
           
          Case #Trackbar_Attack
            Attack = GetGadgetState(#Trackbar_Attack) / 1000
           
          Case #Trackbar_Decay
            Decay = GetGadgetState(#Trackbar_Decay) / 1000
           
          Case #Trackbar_Sustain
            Sustain = GetGadgetState(#Trackbar_Sustain) / 100
           
          Case #Trackbar_Release
            Release = GetGadgetState(#Trackbar_Release) / 1000
              
            
          Case #Trackbar_Stacking
            ;StackingVal = GetGadgetState(#Trackbar_Stacking) 
            ;The Trackbar_Stacking slider has a range from 3 to 50. The default was originally set to 10. The higher the value, the lower the resolution
            ;of display. But we want to reverse this, as it is more intuitive - lower trackbar setting to mean lower resolution and vice versa
            ;to achieve this, we say y = -x+50 (where y is StackingVal and x the slider position). The previous default value of 10 would result
            ;if the slider is set to a value of 43 in this case:
            StackingVal = -GetGadgetState(#Trackbar_Stacking)+53 
              If ListSize(SpectrumSets())>0 
                StackedWaveGrapher()
              EndIf  
            
 Case #XYFirst
           If EventType() = #PB_EventType_MouseMove And GetGadgetAttribute(#XYFirst, #PB_Canvas_Buttons) & #PB_Canvas_LeftButton
            If StartDrawing(CanvasOutput(#XYFirst))
            xq = GetGadgetAttribute(#XYFirst, #PB_Canvas_MouseX)
            yq = GetGadgetAttribute(#XYFirst, #PB_Canvas_MouseY)
            
            If XYPointID = "Unpressed"
                ;Variable A points
                If xq>VarAPoint1X-5 And xq<VarAPoint1X+5 And yq>VarAPoint1Y-5 And yq<VarAPoint1Y+5 
                ElseIf xq>VarAPoint2X-5 And xq<VarAPoint2X+5 And yq>VarAPoint2Y-5 And yq<VarAPoint2Y+5
                  XYPointID = "FirstLine"
                ElseIf xq>VarAPoint3X-5 And xq<VarAPoint3X+5 And yq>VarAPoint3Y-5 And yq<VarAPoint3Y+5
                  XYPointID = "SecondLine"
                ElseIf xq>VarAPoint4X-5 And xq<VarAPoint4X+5 And yq>VarAPoint4Y-5 And yq<VarAPoint4Y+5
                  XYPointID = "ThirdLine" 
                ElseIf xq>VarAPoint5X-5 And xq<VarAPoint5X+5 And yq>VarAPoint5Y-5 And yq<VarAPoint5Y+5
                  XYPointID = "FourthLine" 
                ElseIf xq>VarAPoint6X-5 And xq<VarAPoint6X+5 And yq>VarAPoint6Y-5 And yq<VarAPoint6Y+5
                  XYPointID = "FifthLine"
                ElseIf xq>VarAPoint7X-5 And xq<VarAPoint7X+5 And yq>VarAPoint7Y-5 And yq<VarAPoint7Y+5
                  XYPointID = "SixthLine" 
                ElseIf xq>VarAPoint8X-5 And xq<VarAPoint8X+5 And yq>VarAPoint8Y-5 And yq<VarAPoint8Y+5
                  XYPointID = "SeventhLine"   
                EndIf
              EndIf
               
                    If xq>=0 And xq<=760 And yq>=0 And yq<=30
                    
                      If XYPointID = "FirstLine"  
                        If (xq-VarAPoint1X)<10
                          xq = VarAPoint1X + 10
                        EndIf 
                        If (xq-VarAPoint1X)>105
                          xq = VarAPoint1X + 105
                        EndIf   
                        PointIncrement = xq-VarAOrig2X
                        VarAPoint2X = xq
                        VarAPoint3X = VarAOrig3X+PointIncrement
                        VarAPoint4X = VarAOrig4X+PointIncrement
                        VarAPoint5X = VarAOrig5X+PointIncrement
                        VarAPoint6X = VarAOrig6X+PointIncrement
                        VarAPoint7X = VarAOrig7X+PointIncrement
                        VarAPoint8X = VarAOrig8X+PointIncrement
                        
                      EndIf
                    
                      If XYPointID = "SecondLine"
                        If (xq-VarAPoint2X)<10
                          xq = VarAPoint2X + 10
                        EndIf 
                        If (xq-VarAPoint2X)>105
                          xq = VarAPoint2X + 105
                        EndIf 
                      PointIncrement = xq-VarAOrig3X
                      VarAPoint3X = xq
                      VarAPoint4X = VarAOrig4X+PointIncrement
                      VarAPoint5X = VarAOrig5X+PointIncrement
                      VarAPoint6X = VarAOrig6X+PointIncrement
                      VarAPoint7X = VarAOrig7X+PointIncrement
                      VarAPoint8X = VarAOrig8X+PointIncrement
                      EndIf
                    
                      If XYPointID = "ThirdLine"
                        If (xq-VarAPoint3X)<10
                          xq = VarAPoint3X + 10
                        EndIf 
                        If (xq-VarAPoint3X)>105
                          xq = VarAPoint3X + 105
                        EndIf 
                        PointIncrement = xq-VarAOrig4X
                        VarAPoint4X = xq
                        VarAPoint5X = VarAOrig5X+PointIncrement
                        VarAPoint6X = VarAOrig6X+PointIncrement
                        VarAPoint7X = VarAOrig7X+PointIncrement
                        VarAPoint8X = VarAOrig8X+PointIncrement
                     EndIf
                     
                     If XYPointID = "FourthLine"
                        If (xq-VarAPoint4X)<10
                          xq = VarAPoint4X + 10
                        EndIf 
                        If (xq-VarAPoint4X)>105
                          xq = VarAPoint4X + 105
                        EndIf 
                        PointIncrement = xq-VarAOrig5X
                        VarAPoint5X = xq
                        VarAPoint6X = VarAOrig6X+PointIncrement
                        VarAPoint7X = VarAOrig7X+PointIncrement
                        VarAPoint8X = VarAOrig8X+PointIncrement
                    EndIf
                      
                    If XYPointID = "FifthLine"
                        If (xq-VarAPoint5X)<10
                          xq = VarAPoint5X + 10
                        EndIf 
                        If (xq-VarAPoint5X)>105
                          xq = VarAPoint5X + 105
                        EndIf 
                        PointIncrement = xq-VarAOrig6X
                        VarAPoint6X = xq
                        VarAPoint7X = VarAOrig7X+PointIncrement
                        VarAPoint8X = VarAOrig8X+PointIncrement
                     EndIf
                    
                    If XYPointID = "SixthLine"
                        If (xq-VarAPoint6X)<10
                          xq = VarAPoint6X + 10
                        EndIf 
                        If (xq-VarAPoint6X)>105
                          xq = VarAPoint6X + 105
                        EndIf 
                        PointIncrement = xq-VarAOrig7X
                        VarAPoint7X = xq
                        VarAPoint8X = VarAOrig8X+PointIncrement
                     EndIf   
                     
                     If XYPointID = "SeventhLine"
                        If (xq-VarAPoint7X)<10
                          xq = VarAPoint7X + 10
                        EndIf 
                        If (xq-VarAPoint7X)>105
                          xq = VarAPoint7X + 105
                        EndIf 
                        VarAPoint8X = xq
                     EndIf   
                    
                    
                  EndIf

                      
                  Box(0, 0, 760, 30, $000000)
                  LineXY(VarAPoint4X, VarAPoint4Y, VarAPoint5X, VarAPoint5Y, $686868) 
                  LineXY(VarAPoint5X, VarAPoint5Y, VarAPoint6X, VarAPoint6Y, $686868) 
                  LineXY(VarAPoint6X, VarAPoint6Y, VarAPoint7X, VarAPoint7Y, $686868)
                  LineXY(VarAPoint7X, VarAPoint7Y, VarAPoint8X, VarAPoint8Y, $686868)
                  LineXY(VarAPoint1X, VarAPoint1Y, VarAPoint2X, VarAPoint2Y, $686868) 
                  LineXY(VarAPoint2X, VarAPoint2Y, VarAPoint3X, VarAPoint3Y, $686868) 
                  LineXY(VarAPoint3X, VarAPoint3Y, VarAPoint4X, VarAPoint4Y, $686868) 
                  Circle(VarAPoint1X, VarAPoint1Y, 5, Dot1Color)
                  Circle(VarAPoint2X, VarAPoint2Y, 5, Dot2Color)
                  Circle(VarAPoint3X, VarAPoint3Y, 5, Dot3Color)
                  Circle(VarAPoint4X, VarAPoint4Y, 5, Dot4Color)
                  Circle(VarAPoint5X, VarAPoint5Y, 5, Dot5Color)
                  Circle(VarAPoint6X, VarAPoint6Y, 5, Dot6Color)
                  Circle(VarAPoint7X, VarAPoint7Y, 5, Dot7Color)
                  Circle(VarAPoint8X, VarAPoint8Y, 5, Dot8Color)
                   
            StopDrawing()
          EndIf

         EndIf
      

            
          If EventType() = #PB_EventType_LeftButtonUp
              XYPointID = "Unpressed"
              VarAOrig2X = VarAPoint2X
              VarAOrig3X = VarAPoint3X
              VarAOrig4X = VarAPoint4X 
              
              VarAOrig5X = VarAPoint5X
              VarAOrig6X = VarAPoint6X
              VarAOrig7X = VarAPoint7X 
              VarAOrig8X = VarAPoint8X 
              StackingVal = -GetGadgetState(#Trackbar_Stacking)+53 
              ElapsedTimeBetweenActiveDots()
              
              If ListSize(Dlist())>0
                StackedWaveGrapher()
              EndIf  
            EndIf   
            
            

                                 
        EndSelect
                   
      Case #PB_Event_CloseWindow
        Quit = #True
    EndSelect
  Until Quit
 
EndIf


Pa_AbortStream(Stream)
While Pa_IsStreamActive(Stream) : WaitWindowEvent(1) : Wend
Pa_Terminate()
KillThread(tid_1)
; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 1504
; FirstLine = 1466
; Folding = -----
; EnableThread
; EnableXP
; Executable = Wavefuser_v101.exe
; DisableDebugger